<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995, 1996 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>section 1.6: Arrays</title>
<link href="sx4i.html" rev=precedes>
<link href="sx4k.html" rel=precedes>
<link href="sx4.html" rev=subdocument>
</head>
<body>
<H2>section 1.6: Arrays</H2>

page 22
<p>Note carefully that arrays in C are 0-based,
not 1-based as they are in some languages.

(As we'll see, 0-based arrays turn out to be more convenient 
than 1-based arrays more of the time,
but they may take a bit of getting used to at first.)
</p><p>When they say
``as reflected in the <TT>for</TT> loops
that initialize and print the array,''
they're referring to the fact that the vast majority of 
<TT>for</TT> loops in C look like this:
<pre>	for(i = 0; i &lt; 10; ++i)
</pre>and count from 0 to 9.
The loop
<pre>	for(i = 1; i &lt;= 10; ++i)
</pre>would count from 1 to 10, but loops like this are comparatively 
rare.
(In fact, whenever you see either ``<TT>= 1</TT>''
or ``<TT>&lt;=</TT>'' in a <TT>for</TT> loop,
it's an indication that something unusual is going on
which you'll want to be aware of,
and it may even be a bug.)
</p><p>page 23
</p><p>They've started going a little fast here,
so read up if they're losing you.
What's this magic expression <TT>c-'0'</TT>
that they're using as an array subscript?
Remember, as we saw first on page 19,
that characters in C are represented by small integers
corresponding to their values in the machine's character set.
In ASCII, which most machines use,
<TT>'A'</TT> is character code 65,
<TT>'0'</TT> (zero) is code 48,
<TT>'9'</TT> is code 57,
and all the other characters have their own values which I won't 
bother to list.
If we've just read the character <TT>'9'</TT> from the file,
it has value 57, so <TT>c-'0'</TT> is 57 - 48 which is 9,
and we'll increment cell number 9 in the array,
just like we want to.
Furthermore,
even if we're not using a machine which uses ASCII,
by subtracting <TT>'0'</TT>,
we'll always subtract whatever the right value is to map the 
characters from <TT>'0'</TT> to <TT>'9'</TT> down to the array cell 
range 0 to 9.
</p>
<hr>
<p>
Read sequentially:
<a href="sx4i.html" rev=precedes>prev</a>
<a href="sx4k.html" rel=precedes>next</a>
<a href="sx4.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995, 1996
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
